import re

def load_sdp_table(filename):
	f=open(filename)
	checksum=int(f.readline())

	T=[]
	i=0

	while (i<checksum):
		size_i=int(f.readline())
		item={}
		for j in xrange(size_i):
			line=f.readline()
			(u,v,val)=map(int,str.split(line[:-1]))
			item[(u,v)]=val
		T.append(item)
		i+=size_i

	for line in f.readlines():
		T.append({})
			

	f.close()
	return T
#

def load_matrix(filename):
	L = []
	f = open(filename)
	size = int(f.readline())
	vec_len = int(f.readline())

	for i in xrange(size):
		line=f.readline()[:-1]
		L.append(map(QQ,re.split(' ', line)))
	f.close() 
 
	return matrix(L)
#

def matrix_tr(A,B):
	rows=A.nrows()
	cols=A.ncols()

	tr=0
	for i in xrange(rows):
		for j in xrange(cols):
			add=A[i,j]*B[i,j]
			tr+=add

	return tr
#

def load_vector_list(filename, field=QQ):
	L = []
	f = open(filename)
	size = int(f.readline())
	vec_len = int(f.readline())

	for i in xrange(size):
		line=f.readline()[:-1]
		L.append(map(field,re.split(' ', line)))
	f.close() 
 
	return L
#


dimension = 388


goal_vector=vector(QQ, load_vector_list('goal_vector')[0]) #scaled by 35*27

M_sizes=[42, 70]
F_sizes=[54,71]



value_to_be_proved = 35 # == 1/27 * 945

final_vector = value_to_be_proved*vector(QQ,[1]*dimension)


SDP=len(F_sizes)*[None]
M=len(F_sizes)*[None]
T=len(F_sizes)*[None]
D=[ [] for i in xrange(len(F_sizes)) ]
pairdens=len(F_sizes)*[None]

for i in xrange(len(M_sizes)):
	T[i]=load_matrix('T%d'%(i+1))
	M[i]=load_matrix('N%d'%(i+1))

	SDP[i]=load_sdp_table('pair%d'%(i+1))
	pairdens[i]=[Matrix(QQ,F_sizes[i],F_sizes[i],{}) for tmp in xrange(dimension)]
	
	for j in xrange(dimension):
		for (x,y) in SDP[i][j].keys():
			pairdens[i][j][x,y]=SDP[i][j][(x,y)]
			pairdens[i][j][y,x]=SDP[i][j][(x,y)]
		D[i].append(T[i]*pairdens[i][j]*T[i].T)


posdefcheck=[mat.is_positive_definite() for mat in M]
sys.stdout.write("Test of positive definiteness of all the matrices:")
for i in xrange(len(posdefcheck)):
	if (posdefcheck[i]): sys.stdout.write(" 1")
	else: sys.stdout.write(" 0")
sys.stdout.write("\n")


ok=1
for j in xrange(dimension):
	for i in xrange(len(M)):
		final_vector[j]+= matrix_tr(D[i][j],M[i])
	if final_vector[j]>goal_vector[j]:
		ok=0
		print("the coordinate %d is wrong!"% (j+1))
		break
	elif final_vector[j]==goal_vector[j]:
		print("the coordinate %d is tight!"% (j+1))

if (ok): print "The bound $K_4 >= 1/27$ has been successfully verified."


